<?PHP

  // Ver documentacin sobre objetos, metodos y parametros en https://bitingenieria.com.ar/doc/lsplib
  // Ver documentacion de AFIP en https://www.afip.gob.ar/ws/WSLSP/manual-wslsp-2.0.4.pdf

  $PtoVta = 200;
  $TipoComprobante = 157;

  $wslsp = new COM("lsplib.wslsp") or Die ("lsplib.dll no esta instalado");

  $wslsp->CUIT = 20939802593;
  $wslsp->modoProduccion = false;
  $wslsp->Depurar = true;   // Genera archivos de depuracion Request.xml y Response.xml


  if ($wslsp->login("certificado.crt", "clave.key")) {
      $ConsultaUltimoNroResponse = $wslsp->consultarUltimoNroComprobantePorPtoVta($PtoVta, $TipoComprobante);
      if (!$ConsultaUltimoNroResponse->Respuesta->hayErrores)
      {
          $Solicitud = $wslsp->nuevaLiquidacionAvicola();

          $Solicitud->codOperacion = 203;  //*** CUENTA DE VENTA Y LIQUIDO PRODUCTO CARNE

          $nroComprobante = $ConsultaUltimoNroResponse->Respuesta->nroComprobante + 1;
          $codCaracter = 206;  //206 - CONSIGNATARIO DE CARNE
          $fechaInicioActividades = "2015-07-01";
          $iibb = "30714894664";   //CUIT EMISOR
          $nroRUCA = 2303;    //NRO RUCA EMISOR
          $nroRenspa = "";   //NO TIENE RENSPA EL EMISOR
                   
          
          $Solicitud->emisor($PtoVta, $TipoComprobante, $nroComprobante, $codCaracter, $fechaInicioActividades, "", 1, "");

          $codCaracterRec = 202; //- ESTABLECIMIENTO FAENADOR // es el 202 MATADERO FRIFORIFICO
          $tipoDocRec = 80;   // CUIT
          $nrodocrec = 33616989109;  //CUIT ALIBUE
          $iibbRec = 33616989109;

          $nombreApellidoRec = "ALIBUE SA";
          $domicilioRec = "R 24 KM 4 4";
          $nombreLocalidadRec = "GENERAL RODRIGUEZ";
          $codProvinciaRec = 1;   //VER LISTADO DE PROVINCIA
          $codigoPostalRec = 1748;   //VER LISTADO
          $nroRUCARec = 2303; //2303   //RUCA PROVEEDOR
          //nroRenspaRec = "01.050.0.04563/00"  //RENSPA PROVEEDOR
          $nroRenspaRec = "";  // LO PONGO SIN NADA PORQUE ME DICE QUE TIENE QUE ESTAR VACIO
          
          $Solicitud->receptor($codCaracterRec, $tipoDocRec, $nrodocrec, $iibbRec, $nombreApellidoRec, $domicilioRec, $nombreLocalidadRec, $codProvinciaRec, $codigoPostalRec, $nroRUCARec, $nroRenspaRec);

          $fechaComprobante = "2023-01-27";
          $fechaOperacion = "2022-01-26";
          
          $codMotivo = 203; //REMATE DE CARNE

          //****** NINGUNO DE ESTOS DATOS IRIA EN LA LIQUIDACION 203
          
          $granja_nroGranja = 0;  //****AVERIGUAR A QUE REFERENCIA
          $granja_denominacionGranja = "";
          $granja_nroLoteCrianza = 0;
          $granja_renspaGranja = "";
          $granja_domicilioGranja = "";
          $granja_partidoGranja = "";
          $granja_codLocalidadGranja = 0;
          $granja_codProvinciaGranja = 0;
          $granja_codigoPostalGranja = 0;
          $granja_latitudgranja = 0;
          $granja_longitudgranja = 0;



          //OPCION CON ENVIO DE DATOS
          $Solicitud->datosLiquidacion($fechaComprobante, $fechaOperacion, $codMotivo, $granja_nroGranja, $granja_denominacionGranja, $granja_nroLoteCrianza, $granja_renspaGranja, $granja_domicilioGranja, $granja_partidoGranja, $granja_codLocalidadGranja, $granja_codProvinciaGranja, $granja_codigoPostalGranja, $granja_latitudgranja, $granja_longitudgranja);
         
         //OPCION NULO
         // Solicitud.datosLiquidacion fechaComprobante, fechaOperacion, codMotivo, Null, Null, Null, Null, Null, Null, Null, Null, Null, Null, Null
         
          $codigo = 96;
          $detalle = "";

          $Solicitud->datosLiquidacion_AgregarCondicionVenta($codigo, $detalle);

          $nroRemito = "00002-00226659";
          $Solicitud->AgregarRemito($nroRemito);
          $nroRemito = "00002-00226660";
          $Solicitud->AgregarRemito($nroRemito);
         
          $cuitCliente = 0;
                    
          $tipoLiquidacion = 7;  // KG CARNE AVIAR
          $codCategoria = 1;
          $tipoCarneAviar = 3;

          $cantidad = 100;
          $cantidadCabezas = 0;
          $cantidadKgVivo = 0;
          $precioUnitario = 4000;
          $alicuotaIVA = 10.5;

          $Solicitud->AgregarItemDetalleLiquidacion($cuitCliente, $tipoLiquidacion, $codCategoria, $cantidad, $cantidadCabezas, $cantidadKgVivo, $tipoCarneAviar, $precioUnitario, $alicuotaIVA);

          //tipoComprobanteAsoc = 1;
          //puntoVentaAsoc = 2;
          //nroComprobanteAsoc = 3;
          //nroItemAsoc = 4;
          //cantidadAsociadaAsoc = 5;
          //$Solicitud->AgregarItemDetalleLiquidacionCompraAsoc($tipoComprobanteAsoc, $puntoVentaAsoc, $nroComprobanteAsoc, $nroItemAsoc, $cantidadAsociadaAsoc);

          $Response = $wslsp->generarLiquidacionAvicola();

          if ($Response->Respuesta->hayErrores)
              echo(utf8_encode($Response->Respuesta->errores));
          else {
              $Response->Respuesta->guardarPDF("liquidacion.pdf");
              echo("Felicitaciones, el CAE obtenido: " + strval($Response->Respuesta->cabecera->cae));
            }
      } else
          echo(utf8_encode($ConsultaUltimoNroResponse->Respuesta->errores));

  } else
          echo(utf8_encode($wslsp->ErrorDesc));


?>