<?PHP

  // Ver documentacin sobre objetos, metodos y parametros en https://bitingenieria.com.ar/doc/lsplib
  // Ver documentacion de AFIP en https://www.afip.gob.ar/ws/WSLSP/manual-wslsp-2.0.4.pdf

$PtoVta = 200;
  $TipoComprobante = 183;

  $wslsp = new COM("lsplib.wslsp") or Die ("lsplib.dll no esta instalado");

  $wslsp->CUIT = 20939802593;
  $wslsp->modoProduccion = false;
  $wslsp->Depurar = true;   // Genera archivos de depuracion Request.xml y Response.xml


  if ($wslsp->login("certificado.crt", "clave.key")) {
      $ConsultaUltimoNroResponse = $wslsp->consultarUltimoNroComprobantePorPtoVta($PtoVta, $TipoComprobante);
      if (!$ConsultaUltimoNroResponse->Respuesta->hayErrores)
      {
          $Solicitud = $wslsp->nuevaLiquidacion();
          $Solicitud->codOperacion = 4;
          $Solicitud->emisor->puntoVenta = $PtoVta;
          $Solicitud->emisor->TipoComprobante = $TipoComprobante;
          $Solicitud->emisor->nroComprobante = $ConsultaUltimoNroResponse->Respuesta->nroComprobante + 1;
          $Solicitud->emisor->codCaracter = 5;
          $Solicitud->emisor->fechaInicioActividades = "2005-01-01";
          $Solicitud->emisor->iibb = "20939802593";
          $Solicitud->emisor->nroRUCA = 305;
          $Solicitud->receptor->codCaracter = 3;
          $Solicitud->receptor->operador->CUIT = 20160000024;
          $Solicitud->receptor->operador->iibb = "20160000024";
          $Solicitud->receptor->operador->nroRenspa = "22.123.1.12345/A4";
          $Solicitud->datosLiquidacion->fechaComprobante = "2023-02-27";
          $Solicitud->datosLiquidacion->fechaOperacion = "2023-02-27";
          $Solicitud->datosLiquidacion->lugarRealizacion = "CORONEL SUAREZ";
          $Solicitud->datosLiquidacion->codMotivo = 7;
          $Solicitud->guia(0)->nroGuia = "1";
          $Solicitud->guia(1)->nroGuia = "2";
          $Solicitud->dte(0)->nroDTE = "418-1";
          $Solicitud->dte(1)->nroDTE = "418-1";

          $Solicitud->itemDetalleLiquidacion(0)->cuitCliente = 30160000011;
          $Solicitud->itemDetalleLiquidacion(0)->codCategoria = 51020102;
          $Solicitud->itemDetalleLiquidacion(0)->tipoLiquidacion = 1;
          $Solicitud->itemDetalleLiquidacion(0)->cantidad = 2;
          $Solicitud->itemDetalleLiquidacion(0)->precioUnitario = 20;
          $Solicitud->itemDetalleLiquidacion(0)->alicuotaIVA = 10.5;
          $Solicitud->itemDetalleLiquidacion(0)->Raza->codRaza = 1;

//****************SI LLEVA COMPRA ASOCIADA**************************************************
//          $Solicitud->itemDetalleLiquidacion(0)->liquidacionCompraAsociada(0)->tipoComprobante = 185
//          $Solicitud.itemDetalleLiquidacion(0).liquidacionCompraAsociada(0).puntoVenta = 3000
//          $Solicitud->itemDetalleLiquidacion(0)->liquidacionCompraAsociada(0)->nroComprobante = 33
//          $Solicitud.itemDetalleLiquidacion(0).liquidacionCompraAsociada(0).nroItem = 1
//          $Solicitud->itemDetalleLiquidacion(0)->liquidacionCompraAsociada(0)->cantidadAsociada = 2


          $Solicitud->gasto(0)->codGasto = 16;
          $Solicitud->gasto(0)->baseImponible = 230520.6;
          $Solicitud->gasto(0)->alicuota = 3;
          $Solicitud->gasto(0)->alicuotaIVA = 10.5;

          $Solicitud->tributo(0)->codTributo = 5;
          $Solicitud->tributo(0)->baseImponible = 30520;
          $Solicitud->tributo(0)->alicuota = 2.5;
          $Solicitud->datosAdicionales = "Datos Adicionales";
          $Response = $wslsp->generarLiquidacion();

          if ($Response->Respuesta->hayErrores)
              echo(utf8_encode($Response->Respuesta->errores));
          else {
              $Response->Respuesta->guardarPDF("liquidacion.pdf");
              echo("Felicitaciones, el CAE obtenido: " + CStr($Response->Respuesta->cabecera->cae));
            }
      } else
          echo(utf8_encode($ConsultaUltimoNroResponse->Respuesta->errores));

  } else
          echo(utf8_encode($wslsp->ErrorDesc));


?>